

/* 
 * система кольцевого охлождения
 * настройки
*/
$fn = 150;

//
glFanHotendInside = 26;							// внутренней диаметр обдува хотенда
glFanHotendOutside = glFanHotendInside + 45;	// внешний диаметр хотенда
glFanHotend = 6;								// щель для обдува
//

//
glFanHotendDepth = 18;							// толщина бошмака обдува
glThickness = 2.1;								// толщина стенки обдува
//


//
glRotorShiftX	= 47;							// смещение двигателя
glRotorShiftY	= -18;
glRotorSize		= 80;							// размер мотора
glRotorFanSize	= glRotorSize - 10;				// диаметр посадочного отверстия
glRotorScrew	= glRotorSize / 2 - 5;			// дырки от центра


glKFX			= -0.265;//0.3;
glKFY			= 0.61;//1.07;
glKFRadius		= glRotorSize * 0.4;
//



glRotorSX		= -glFanHotendDepth - 10;			// смещение ротора



//-------------------------------------------------------------------------------------//
//
//
// сборка отрисовки
//
//
module fan()
{
difference()
{
	union()
	{
		//рисуем общий вид
		fanHotend();
		tube();
		translate([glRotorShiftX, glRotorShiftY, 0]) rotor();

	}

	//вырезаем внешние штуки
	fanHotendOutside();

	//вырезаем внутренности
	fanHotendInside();
	translate([glRotorShiftX, glRotorShiftY,0]) rotorInside();
	tubeInside();


	

	//отладка
	//#translate([-50,0,-0.1])cube([200,50,50]);
	
	//#translate([glRotorShiftX - 10  , -25,-0.1])cube([120,50,80]);
}

//поддержка
cylinder(r = glFanHotendOutside / 2, h = 0.1);
}


//
//
//
//
//-------------------------------------------------------------------------------------//








/* //===================================================================================*
* //                                                                                    *
* // отрисовка обдува вокруг сопла          											*
* //------------------------------------------------------------------------------------*
*///
module fanHotend()
{
	cylinder(r=glFanHotendOutside / 2, h=glFanHotendDepth);
}
//-------------------------------------------------------------------------------------//









/* //===================================================================================*
* //                                                                                    *
* // вырезаем внешние штуки	у обдува        											*
* //------------------------------------------------------------------------------------*
*///
module fanHotendOutside()
{
	 //внешняя дыра под сопло
	 translate([0,0, -1])cylinder(r = glFanHotendInside / 2, h = glFanHotendDepth + glThickness * 2);


	 //конусное отверстие
	 iIradius1 = glFanHotendInside / 2;
	 iIradius2 = iIradius1 + glFanHotendDepth;
	 translate([0,0, 1])cylinder(		r1 = iIradius1, 
										r2 = iIradius2 ,	
										h = glFanHotendDepth);
}
//-------------------------------------------------------------------------------------//






/* //===================================================================================*
* //                                                                                    *
* // вырезаем внутряннку обдува		        											*
* //------------------------------------------------------------------------------------*
*///
module fanHotendInside()
{
	 iIradius1 = glFanHotendInside / 2;
	 iIradius2 = iIradius1 + glFanHotendDepth;
	 iDepth =  glFanHotendDepth - glThickness * 2 - 0.01;

	 difference()
	 {
		 //внутренняя дырка под сопло
		 union()
		 {
			translate([0,0, glThickness])cylinder(r = glFanHotendOutside / 2 - glThickness, h = iDepth);
			translate([0,0, -glThickness * 2])
				cylinder(	r1 = iIradius1 + glFanHotend,
							r2 = iIradius1 + iDepth, 
							h = iDepth - glFanHotend);
		}

	 
		 //конусное отверстие
		 translate([0,0, -glThickness])cylinder(	r1 = iIradius1, 
													r2 = iIradius2 ,	
													h = glFanHotendDepth);
	}
	
}
//-------------------------------------------------------------------------------------//












/* //===================================================================================*
* //                                                                                    *
* // двигатель        																	*
* //------------------------------------------------------------------------------------*
*///
module rotor()
{

	iz = 3;

	translate([glRotorSX, -glRotorSize/2 ,0])
	{
		difference()
		{
			//сам куб
			translate([0, 0, iz]) rotate([0, 45, 0])cube([glRotorSize, glRotorSize, glRotorSize]);

			//отрезаем все лишнее
			//нижняя граница
			translate([0, -1, -glRotorSize])cube([glRotorSize * 1.5, glRotorSize + 2, glRotorSize ]);


			//отрезаем зад
			translate([-glRotorSize - glRotorSX + glThickness, -1, -1])cube([glRotorSize, glRotorSize + 2, glFanHotendDepth + glThickness + 1]);

			//оттрезаем выемку
			rotate([90,0,0]) translate([-glRotorSize *glKFX, glRotorSize * glKFY, -glRotorSize - 1])cylinder( r = glKFRadius, h = glRotorSize + 2);
		}
	}
}
//-------------------------------------------------------------------------------------//









/* //===================================================================================*
* //                                                                                    *
* // двигатель вырезка внутрення														*
* //------------------------------------------------------------------------------------*
*///
module rotorInside()
{
	iSize = glRotorSize - glThickness * 2; 

	iz = 3;
	translate([glRotorSX,-glRotorSize/2,0])
	union()
	{
		difference()
		{
			//сам куб
			translate([glThickness, glThickness, iz]) rotate([0, 45, 0])
			union()
			{
				cube([iSize, iSize, iSize]);
				
				translate([iSize / 2 , iSize / 2 , iSize - 1]) 
				union()
				{
					//дырка под вентилятор
					cylinder(r = glRotorFanSize / 2, h = glThickness + 2);
					
					//дырки под крепление
					translate([glRotorScrew, glRotorScrew, 0]) cylinder(r = 1, h = glThickness + 2);
					translate([glRotorScrew, -glRotorScrew, 0]) cylinder(r = 1, h = glThickness + 2);
					translate([-glRotorScrew, glRotorScrew, 0]) cylinder(r = 1, h = glThickness + 2);
					translate([-glRotorScrew, -glRotorScrew, 0]) cylinder(r = 1, h = glThickness + 2);
				}
			}

			//отрезаем все лишнее
			//нижняя граница
			translate([0, -1, -glRotorSize / 1.5 + glThickness])cube([glRotorSize * 1.5, glRotorSize + 2, glRotorSize / 1.5]);


			//отрезаем зад
			translate([-glRotorSize - glRotorSX + glThickness, -1, -1])cube([glRotorSize, glRotorSize + 2, glFanHotendDepth + glThickness + 1]);

			//оттрезаем выемку
			rotate([90,0,0]) translate([-iSize *glKFX + glThickness * 0.3, iSize * glKFY + glThickness * 1.1, -iSize - 2])cylinder( r = glKFRadius + glThickness, h = iSize + 4);
		}
	}
}
//-------------------------------------------------------------------------------------//















/* //===================================================================================*
* //                                                                                    *
* // соеденительная труба, между соплом и ротором        								*
* //------------------------------------------------------------------------------------*
*///
module tube()
{
	iRotR = glRotorSize / 2; //радиус ротора

	hull()
	{
		//
		//сначало построим промежуточное кольцо у ротора 
		//
		translate([glRotorShiftX + glThickness, glRotorShiftY - glRotorSize /2, 0])
			union()
			{
				difference()
				{
					translate([0, glRotorSize / 2, 0]) cylinder(r = iRotR, h = glFanHotendDepth);

					translate([0,0,-1]) cube([iRotR, glRotorSize, glFanHotendDepth + 2]);
				
					//translate([-1, glThickness, glThickness]) cube([5, glRotorSize - glThickness * 2, glFanHotendDepth - glThickness * 2]);
				}
			}



		//
		// соеденительный элемент
		//
		cylinder(r=glFanHotendOutside / 2, h=glFanHotendDepth);

	}


}
//-------------------------------------------------------------------------------------//















/* //===================================================================================*
* //                                                                                    *
* // соеденительная труба, между соплом и ротором        								*
* //------------------------------------------------------------------------------------*
*///
module tubeInside()
{
	iRotR = glRotorSize / 2; //радиус ротора

	difference()
	{
		hull()
		{
			//
			//сначало построим промежуточное кольцо у ротора 
			//
			translate([glRotorShiftX + glThickness, glRotorShiftY - glRotorSize /2, 0])
				union()
				{
					difference()
					{
						translate([0, glRotorSize / 2, glThickness]) cylinder(r = iRotR - glThickness, h = glFanHotendDepth - glThickness * 2);
						translate([1,0,-1]) cube([iRotR, glRotorSize, glFanHotendDepth + 2]);
				
						//translate([-1, glThickness, glThickness]) cube([5, glRotorSize - glThickness * 2, glFanHotendDepth - glThickness * 2]);
					}
				}



			//
			// соеденительный элемент
			//
			translate([0,0,glThickness])cylinder(r=glFanHotendOutside / 2 - glThickness, h=glFanHotendDepth - glThickness * 2);
		}


		cylinder(r=glFanHotendOutside / 2 - glThickness - 1, h=glFanHotendDepth);

		translate([glRotorShiftX + glThickness - 20, glRotorShiftY + 7, 0]) rotate([0,0,-20]) cube([30, glThickness, glFanHotendDepth]);

		translate([glRotorShiftX + glThickness / 2, glRotorShiftY - glRotorSize / 2, glFanHotendDepth - glThickness   - 1]) cube([glThickness, glRotorSize, 1]);
	}

}
//-------------------------------------------------------------------------------------//


iTop = 51.8 - 8;


iSize = glRotorSize - glThickness * 2; 


fan();


//отверстие под крепление
//translate([44, -22,iTop])translate([-10,0,0])cube([10,14,2]);

/*

//крепление расстояние
intersection()
{
	translate([45,-35,iTop])
	difference()
	{
		//
		union()
		{
			//нижняя платформа
			translate([0,0, -8 - 3])cube([27,40,8]);

			//платформа крепления
			translate([0,0,-5])cube([5,40,10]);

			translate([18,0,-20])cube([5,40,10]);
		
			translate([18,0,-3])rotate([0,30,0])cube([10,40,20]);
		}

		//дырки под крепление
		translate([-5,(40 / 2 + 14 /2),0 ])rotate([0,90,0])cylinder(r=1.5, h= 15);
		translate([-5,(40 / 2 - 14 /2),0 ])rotate([0,90,0])cylinder(r=1.5, h= 15);
	

	}

	//отрезаем зад
	//оттрезаем выемку
	
	translate([glRotorShiftX, glRotorShiftY,0])
	translate([glRotorSX,-glRotorSize/2,0])
	rotate([90,0,0]) translate([-iSize *glKFX + glThickness * 0.3, iSize * glKFY + glThickness * 1.1, -iSize - 2])cylinder( r = glKFRadius , h = iSize + 4);
}

*/